'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _yeomanGenerator = require('yeoman-generator');

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _pathExists = require('path-exists');

var _pathExists2 = _interopRequireDefault(_pathExists);

var _simpleGit = require('simple-git');

var _simpleGit2 = _interopRequireDefault(_simpleGit);

var _slug = require('slug');

var _slug2 = _interopRequireDefault(_slug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MyGenerator = function (_Base) {
  _inherits(MyGenerator, _Base);

  function MyGenerator() {
    var _Object$getPrototypeO;

    _classCallCheck(this, MyGenerator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(MyGenerator)).call.apply(_Object$getPrototypeO, [this].concat(args)));

    _slug2.default.defaults.mode = 'rfc3986';
    _this.opts = {
      year: new Date().getFullYear()
    };
    return _this;
  }

  _createClass(MyGenerator, [{
    key: 'prompting',
    value: function prompting() {
      var _this2 = this;

      var done = this.async();
      var prompts = [{
        type: 'input',
        name: 'projectName',
        message: 'Enter the name of your project:',
        default: 'name-of-your-project'
      }, {
        type: 'input',
        name: 'description',
        message: 'Enter a description of your project:'
      }, {
        type: 'input',
        name: 'githubName',
        message: 'Enter your github username:',
        store: true
      }, {
        type: 'input',
        name: 'buildDir',
        message: 'Enter the name of your build directory:',
        default: 'build'
      }];
      this.prompt(prompts, function (res) {
        _this2.opts.projectName = (0, _slug2.default)(res.projectName);
        var dir = _path2.default.join('.', _this2.opts.projectName);
        if (!_pathExists2.default.sync(dir)) _this2.destinationRoot(dir);else _this2.env.error('the directory \'' + _this2.opts.projectName + '\' already exists!');
        _this2.git = (0, _simpleGit2.default)(_this2.destinationRoot());
        _this2.opts.description = res.description;
        _this2.opts.githubName = res.githubName;
        _this2.opts.buildDir = (0, _slug2.default)(res.buildDir);
        done();
      });
    }
  }, {
    key: 'install',
    value: function install() {
      this.installDependencies();
    }
  }, {
    key: 'end',
    value: function end() {
      this.log('\'' + this.opts.projectName + '\' is all set up and ready to go!');
    }
  }, {
    key: 'writing',
    get: function get() {
      return {
        // create root directory files

        rootFiles: function rootFiles() {
          this.fs.copy(this.templatePath('babelrc'), this.destinationPath('.babelrc'));
          this.fs.copy(this.templatePath('eslintrc.json'), this.destinationPath('.eslintrc.json'));
          this.fs.copyTpl(this.templatePath('_bower.json'), this.destinationPath('bower.json'), this.opts);
          this.fs.copyTpl(this.templatePath('_gulpfile.babel.js'), this.destinationPath('gulpfile.babel.js'), this.opts);
          this.fs.copyTpl(this.templatePath('_LICENSE'), this.destinationPath('LICENSE'), this.opts);
          this.fs.copyTpl(this.templatePath('_package.json'), this.destinationPath('package.json'), this.opts);
        },

        // express app config and files
        app: function app() {
          this.fs.copy(this.templatePath('src/app.js'), this.destinationPath('src/app.js'));
          this.fs.copyTpl(this.templatePath('src/app/controllers/_index.js'), this.destinationPath('src/app/controllers/index.js'), this.opts);
          this.fs.copy(this.templatePath('src/app/controllers/extras.js'), this.destinationPath('src/app/controllers/extras.js'));
          this.directory(this.templatePath('src/app/models'), this.destinationPath('src/app/models'));
          this.directory(this.templatePath('src/app/views'), this.destinationPath('src/app/views'));
        },

        // remaining source files
        src: function src() {
          (0, _mkdirp2.default)(_path2.default.join(this.destinationRoot(), 'src/files'));
          this.directory(this.templatePath('src/fonts'), this.destinationPath('src/fonts'));
          this.directory(this.templatePath('src/images'), this.destinationPath('src/images'));
          this.directory(this.templatePath('src/scripts'), this.destinationPath('src/scripts'));
          this.directory(this.templatePath('src/styles'), this.destinationPath('src/styles'));
        },

        // create local git and commit all files
        git: function git() {
          this.fs.copyTpl(this.templatePath('_gitignore'), this.destinationPath('.gitignore'), this.opts);
          this.fs.copyTpl(this.templatePath('_README.md'), this.destinationPath('README.md'), this.opts);
          this.git.init().add('.').commit(this.opts.projectName + ' initial commit');
        }
      };
    }
  }]);

  return MyGenerator;
}(_yeomanGenerator.Base);

module.exports = MyGenerator;